#include <wx/mstream.h> //para wxMemoryInputStream
//#include <mbstring.h> //para _mbsnbicmp
#include <string.h> //para _stricmp
#include <wx/wx.h>
#include "CMarco.h"
#include "ident.h"

BEGIN_EVENT_TABLE(CMarco,wxFrame)
	EVT_MENU(wxID_ABOUT, CMarco::OnAbout)
	EVT_MENU(wxID_EXIT, CMarco::OnQuit)
	EVT_MENU(ID_MENU_OPEN_FILE, CMarco::onAbrirFichero)
	EVT_MENU(ID_MENU_OPEN_FILE_PERIMETRO, CMarco::onAbrirFicheroPerimetro)
	EVT_MENU(ID_MENU_CLOSE_FILE, CMarco::onCerrarFichero)
	EVT_MENU_RANGE(0,20, CMarco::onCargarTile)
	EVT_PAINT(CMarco::OnPaint)
	EVT_SIZE(CMarco::OnSize)
	EVT_KEY_DOWN(CMarco::onKeyDown)
END_EVENT_TABLE()

wxMenu *CMarco::crearMenuItemFile(void)
{
 wxMenu *lpMenuFile;

 lpMenuFile=new wxMenu();
 lpMenuFile->Append(ID_MENU_OPEN_FILE,wxT("Abrir MBTile"),TXT_TITULO_APP);
 lpMenuFile->Append(ID_MENU_OPEN_FILE_PERIMETRO,wxT("Abrir MBTile Perímetro"),TXT_TITULO_APP);
 lpMenuFile->Append(ID_MENU_CLOSE_FILE,wxT("Cerrar"),TXT_TITULO_APP);
 lpMenuFile->AppendSeparator();
 lpMenuFile->Append(wxID_EXIT,wxT("Salir"));

 return lpMenuFile;
}

wxMenu *CMarco::crearMenuItemZooms(void)
{
 wxMenu *lpMenuFile;
 unsigned int luiNumZooms;
 unsigned int luiIndi;
 int liZoom;
 wxString lstrItem;


 luiNumZooms=mFileTiles.obtNumZooms();
 if (luiNumZooms==0)
  return NULL;

 lpMenuFile=new wxMenu();

 for (luiIndi=0; luiIndi<luiNumZooms; luiIndi++)
 {
  liZoom=mFileTiles.obtInfoPosZoom(luiIndi);
  mVecIdMenuItemsZooms.push_back(liZoom);
  lstrItem.Printf(wxT("Zoom: %i"),liZoom);
  lpMenuFile->AppendCheckItem(luiIndi,lstrItem,wxEmptyString);
 }

 return lpMenuFile;
}

char CMarco::tilesToAzulejos(void)
{
 int liX,liY;
 int liFila,liColumna;
 tile lTile;
 char lchEstado;
 wxBitmap *lpBitmap;
 unsigned int luiNumItems;
 int liMaxFila;
 int liMinCol;
 unsigned int luiIndi;
 bool lbErrorBitmap;

 borrarVectorBitmaps();
 liX=0;
 liY=0;
 lbErrorBitmap=false;

 //obtenemos el número de tiles del zoom cargado.
 luiNumItems=mFileTiles.obtNumTilesCargados();
 if (luiNumItems<=0)
  return -1;

 //obtenemos la máxima fila y la mínima columna que forman el zoom cargado.
 liMaxFila=mFileTiles.obtMaxFila();
 liMinCol=mFileTiles.obtMinColumna();


 for (luiIndi=0;luiIndi<luiNumItems;luiIndi++)
 {//recorremos los tiles del zoom cargado
  imagen lImagen;
  //obtenemos el tile. que nos indica el zoom al que pertenece,
  //fila y columna al que pertenece
  //tamaño en bytes de la imagen
  //datos de la imagen
  lTile=mFileTiles.obtTileByIndice(luiIndi,&lchEstado);

  liFila=lTile.fila;
  liColumna=lTile.columna;
  //creamos un bitmap con los datos del tile.
  lpBitmap=creaBitmap(lTile.pRawImg,lTile.sizeBytes,liFila,liColumna);

  if (lpBitmap==NULL)
  {//no se ha podido crear el bitmap
   lbErrorBitmap=true;
   break;
  }//fin no se ha podido crear el bitmap

  //la imagen la tenemos en 2 sitios en lpBitmap y en la instancia del MBTiles (mFileTiles),
  //borramos la información de la imagen del tile en la instancia del MBTiles
  mFileTiles.borrarRawImg(luiIndi);

  //pasamos tile la estructura imagen, que es lo que se dibujara por pantalla
  lImagen.graf=lpBitmap;
  //calculamos la coordenada X,Y donde se dibujara el bitmap
  liX=(liColumna-liMinCol)*lpBitmap->GetWidth();
  liY=(liMaxFila-liFila)*lpBitmap->GetHeight();
  lImagen.posBitmap.x=liX;
  lImagen.posBitmap.y=liY;

  //guardamos la imagen en el vector.
  mVecBitmap.push_back(lImagen);
  //fin recorremos los tiles del zoom cargado
 }

 //borramos todos los tiles que hay en la instancia mFileTiles
 mFileTiles.borrarTiles();
 if (lbErrorBitmap==true)
 {
  borrarVectorBitmaps();
  return -2;
 }
 return 0;
}

wxBitmap *CMarco::creaBitmap(const unsigned char *ppRaw, int piSize, unsigned int piFila, unsigned int piColumna)
{
 wxMemoryInputStream lMemory(ppRaw,piSize);
 wxImage lImagen;
 wxBitmap *lpBitmap;
 wxMemoryDC lMenDC;

 wxRect lRec;
 wxSize lSizeBitmap;
 wxPoint lPosText;
 wxString lstrText;


 lpBitmap=NULL;
 if (_stricmp((const char *)"jpg",(const char *)mFileTiles.obtFormatoImg())==0)
 {
  lImagen.LoadFile(lMemory,wxBITMAP_TYPE_JPEG);
  lpBitmap=new wxBitmap(lImagen);
 }
 else
    {
     if (_stricmp((const char *)"png",(const char *)mFileTiles.obtFormatoImg())==0)
     {
      lImagen.LoadFile(lMemory,wxBITMAP_TYPE_PNG);
      lpBitmap=new wxBitmap(lImagen);
     }
     else
        lpBitmap=NULL; //formato desonocido
    }

 if (lbDibujaPerimetroTiles==true)
 {//hemos cargado el fichero para que dibuje el perimietro.
  //en cada azulejo dibujamos su borde y en el centro la columna y fila
  if (lpBitmap!=NULL)
  {
   lSizeBitmap=lpBitmap->GetSize();

   lMenDC.SelectObject(*lpBitmap);
   lMenDC.SetPen(*wxRED_PEN);
   lMenDC.SetBrush(*wxTRANSPARENT_BRUSH);
   lRec.SetX(0);
   lRec.SetY(0);
   lRec.SetSize(lSizeBitmap);
   lMenDC.DrawRectangle(lRec);
   //dibujamos las coordenadas (columna,fila)
   lPosText.x=int(lSizeBitmap.GetWidth()/2)-20;
   lPosText.y=int(lSizeBitmap.GetHeight()/2);
   lstrText.Printf("C:%u F:%u",piColumna,piFila);
   lMenDC.SetTextForeground(*wxRED);
   lMenDC.DrawText(lstrText,lPosText);

   lMenDC.SelectObject(wxNullBitmap);
  }//fin hemos cargado el fichero para que dibuje el perimietro.
 }

 return lpBitmap;
}

void CMarco::borrarVectorBitmaps(void)
{
 std::vector<imagen>::iterator lIterator;
 imagen lAzulejo;

 if (mVecBitmap.size()<=0)
  return;

 for (lIterator=mVecBitmap.begin();lIterator!=mVecBitmap.end(); lIterator++)
 {
  lAzulejo=*lIterator;
  if (lAzulejo.graf!=NULL)
  {
   delete lAzulejo.graf;
   lAzulejo.graf=NULL;
  }
 }
 mVecBitmap.clear();
}


CMarco::CMarco(const wxString& title) : wxFrame(NULL, wxID_ANY, title)
{
 //posicion donde se dibujara el mapa
 mPosMapa.x=0;
 mPosMapa.y=0;
 lbDibujaPerimetroTiles=false;


 mpMenuZooms=NULL;
 mpMainMenu=new wxMenuBar();
 mpMenuFile=crearMenuItemFile();
 mpMainMenu->Append(mpMenuFile,wxT("Fichero"));
 SetMenuBar(mpMainMenu);
}

CMarco::~CMarco(void)
{
 borrarVectorBitmaps();
}


void CMarco::OnAbout(wxCommandEvent& event)
{
 wxString msg;
 msg.Printf(wxT("Hello and welcome to %s"), wxVERSION_STRING);
 wxMessageBox(msg, wxT("About Minimal"),wxOK | wxICON_INFORMATION, this);
}


void CMarco::OnQuit(wxCommandEvent& event)
{
 // Destroy the frame
 Close();
}

void CMarco::abrirFichero(void)
{
 wxFileDialog lDlgFile(this, wxT("Abrir fichero"),wxEmptyString,wxEmptyString,
  		       wxT("MBTtiles (*.mbtiles)|*.mbtiles"),wxFD_OPEN);
 wxString lstrPath;
 char lchEstado;
 wxString lstrMsj;

 mVecIdMenuItemsZooms.clear();
 if (mpMenuZooms!=NULL)
 {
  mpMainMenu->Remove(mpMainMenu->FindMenu(wxT("Zooms")));
  delete mpMenuZooms;
 }

 if (lDlgFile.ShowModal() == wxID_OK)
 {//todo va bien
  lstrPath=lDlgFile.GetPath();
  lchEstado=mFileTiles.leerFichero((const char*)lstrPath.c_str());
  if (lchEstado<0)
  {//se ha prodicido un error a la hora de abrir el fichero
   switch(lchEstado)
   {
    case -10:
       {
        lstrMsj=wxT("No se ha podido abrir el fichero");
        break;
       }
    case -20:
       {
        lstrMsj=wxT("No se ha podido obtener el parámetro ZOOM");
        break;
       }
    case -30:
       {
        lstrMsj=wxT("No se ha podido obtener el parámetro FORMAT");
        break;
       }
    case -40:
       {
        lstrMsj=wxT("El formato de la imagen desconocido");
        break;
        }
    case -50:
       {
        lstrMsj=wxT("No se ha podido obtener los zooms");
        break;
       }
    default:
       {
        lstrMsj.Printf(wxT("Error desconocido:%i"),lchEstado);
       }
   }
   wxMessageBox(lstrMsj,TXT_TITULO_APP,wxOK|wxICON_WARNING);
   return;
  }//fin se ha producido un error a la hora de abrir el fichero
  //si todo va bien
  lstrMsj.Printf(wxT("%s - %s"),TXT_TITULO_APP,lstrPath);
  SetTitle(lstrMsj);


  mpMenuZooms=crearMenuItemZooms();
  if (mpMenuZooms!=NULL)
  {
   mpMainMenu->Append(mpMenuZooms,wxT("Zooms"));
  }
 }//fin todo va bien
}

void CMarco::onAbrirFichero(wxCommandEvent& event)
{
 lbDibujaPerimetroTiles=false;
 abrirFichero();
}

void CMarco::onAbrirFicheroPerimetro(wxCommandEvent& event)
{
 lbDibujaPerimetroTiles=true;
 abrirFichero();
}

void CMarco::onCerrarFichero(wxCommandEvent& event)
{
 int liIndex;

 //libreamos memoria
 mVecIdMenuItemsZooms.clear();
 liIndex=mpMainMenu->FindMenu("Zooms");
 if (liIndex==wxNOT_FOUND)
  return;

 mpMainMenu->Remove(liIndex);
 Refresh(true,NULL);
}

void CMarco::onCargarTile(wxCommandEvent& event)
{
 unsigned int luiNumItems;
 unsigned int luiPos;
 unsigned int luiNumTilesZoom;
 wxMenuItem *lpMenuItemZoom;

 //debemos de desmarcar el otro item
 luiNumItems=mVecIdMenuItemsZooms.size();
 for (luiPos=0;luiPos<luiNumItems;luiPos++)
 {
  if (luiPos==(unsigned int)event.GetId())
  {
   continue;
  }
  lpMenuItemZoom=mpMenuZooms->FindItemByPosition(luiPos);
  if (lpMenuItemZoom->IsChecked()==true)
   lpMenuItemZoom->Check(false);
 }

 //ahora debo de cargar el item
 miZoom=mVecIdMenuItemsZooms.at(event.GetId());
 //caramos los tiles del zoom (miZoom)
 if (mFileTiles.cargarTiles(miZoom,&luiNumTilesZoom)==0)
 {
  if (luiNumItems>0)
  {
   tilesToAzulejos();
   //hemos cargado un nuevo mapa.
   //el nuevo mapa se dibujara en la corrdenadas 0,0
   mPosMapa.x=0;
   mPosMapa.y=0;
   //fuerza a lanzar el onPaint
   Refresh(true,NULL);
  }
 }
}


void CMarco::OnPaint(wxPaintEvent& event)
{
 wxPaintDC lDc(this);
 unsigned int luiNumTiles;
 unsigned int luiIndi;
 imagen lImg;
 wxPoint lPosDibujaAzulejo;

 //obtenemos el numero de imagnes(tiles) a dibujar
 luiNumTiles=mVecBitmap.size();

 for (luiIndi=0;luiIndi<luiNumTiles;luiIndi++)
 {//por cada imagen
  lImg=mVecBitmap[luiIndi];

  //calculamos la posicion de la imagen que vamos a dibujar
  //a partir de la posicion del mapa (mPosMapa)
  lPosDibujaAzulejo.x=lImg.posBitmap.x+mPosMapa.x;
  lPosDibujaAzulejo.y=lImg.posBitmap.y+mPosMapa.y;

  //dibujamos el la imagen (tile)
  lDc.DrawBitmap(*lImg.graf,lPosDibujaAzulejo,false);
 }
}

void CMarco::OnSize(wxSizeEvent& event)
{
 Refresh(true,NULL);
}


void CMarco::onKeyDown(wxKeyEvent& event)
{
 switch (event.GetKeyCode())
 {
  case WXK_RIGHT:
     {//tecla DERECHA
      mPosMapa.x=mPosMapa.x-10;
      //con true forzamos a que el backgroun se borre
      Refresh(true,NULL);
      break;
     }
  case WXK_LEFT:
     {//tecla izquierda (316)
      mPosMapa.x=mPosMapa.x+10;
      //con true forzamos a que el backgroun se borre
      Refresh(true,NULL);
      break;
     }
  case WXK_UP:
     {//tecla ARRIBA
      mPosMapa.y=mPosMapa.y+10;
      //con true forzamos a que el backgroun se borre
      Refresh(true,NULL);
      break;
     }
  case WXK_DOWN:
     {//tecla ABAJO
      mPosMapa.y=mPosMapa.y-10;
      //con true forzamos a que el backgroun se borre
      Refresh(true,NULL);
      break;
     }
 }
}


