#ifndef COMPGRAF_CMARCO_H_
#define COMPGRAF_CMARCO_H_

//#include <wx/frame.h>
#include <wx/wx.h>
#include <vector>
#include "CFicheroMBTiles/CFicheroMBTiles.h"

#define TXT_TITULO_APP wxT("Visor de tiles")

typedef struct
{
 //guardamos la posicion x, y, donde se dibujara del bitmap
 wxPoint posBitmap;
 wxBitmap *graf;
} imagen;


class CMarco : public wxFrame
{
 private:
  // This class handles events
  DECLARE_EVENT_TABLE()

  CFicheroMBTiles mFileTiles;
  std::vector<int> mVecIdMenuItemsZooms;
  int miZoom;

  wxMenuBar *mpMainMenu;
  wxMenu *mpMenuFile;
  wxMenu *mpMenuZooms;
  std::vector<imagen> mVecBitmap;
  //posicion donde dibujaremos el mapa
  wxPoint mPosMapa;
  bool lbDibujaPerimetroTiles;

  wxMenu *crearMenuItemFile(void);
  wxMenu *crearMenuItemZooms(void);
  char tilesToAzulejos(void);
  wxBitmap *creaBitmap(const unsigned char *ppRaw, int piSize, unsigned int piFila, unsigned int piColumna);
  void borrarVectorBitmaps(void);
  void abrirFichero(void);

 public:
  // Constructor
  CMarco(const wxString& title);
  ~CMarco(void);

  // Event handlers
  void onAbrirFichero(wxCommandEvent& event);
  void onAbrirFicheroPerimetro(wxCommandEvent& event);
  void onCerrarFichero(wxCommandEvent& event);
  void onCargarTile(wxCommandEvent& event);

  void OnQuit(wxCommandEvent& event);
  void OnAbout(wxCommandEvent& event);
  void OnPaint(wxPaintEvent& event);
  void OnSize(wxSizeEvent& event);
  void onKeyDown(wxKeyEvent& event);

};



#endif /* COMPGRAF_CMARCO_H_ */
